#ifndef _RAMPABUS_H_
	#define _RAMPABUS_H_
	
	#include "stm32f4xx.h"
	#include "stm32f4xx_conf.h"
	
	#include <string.h>
	#include "fs_port.h"
	#include "error.h"
	#include "debug.h"
	#include "ff.h"
	#define PINGDAT 0xfafa
	#define DIR 1
	#define GRU 0  //ojo GRU 0 es todo los grupos
	#define MAX_FUNCION 20
	
	typedef enum {inicio=0,final,pendiente,repuesta,asistencias}Normas;
	typedef enum {todos=0,esclavo,grupo} Grupos; 
	
	typedef enum{DIRECCION=0,GRUPOS,FUNCION}TipoIdx;
	typedef enum{IDX_NORMAL,IDX_ELIMINADO,IDX_FIN,IDX_INICIO}AttrIdx;
	
	extern const uint8_t  NORMAL;
	extern const uint8_t  DEL;
	extern const uint8_t  CAB_INI;
	extern const uint8_t  CAB_FIN; 
	
	extern const uint32_t OFFSET_INI_FILE;
	extern const uint32_t OFFSETCUR1_VAR;
	extern const uint32_t OFFSETCUR2_VAR;
	
	
	typedef struct{
		uint8_t Normas;
		uint8_t Grupos;
		uint8_t Direccion;
		uint8_t Funcion;
		uint8_t Tamdatas;
		
		
	}Capsula;
	
	typedef union{
		uint8_t Data[5];
		Capsula cap;
	}Cap_Data;
	
	typedef struct {
		uint32_t ant;
		uint32_t sig;
		uint32_t tam;
		uint8_t attr;
		/*
		uint8_t operator==(CapFile &fil){
			if(fil.ant==ant && fil.sig==sig && fil.tam==tam && fil.attr==attr) return 1;
			else return 0;
		};
		*/
	}CapFile;
	
	typedef struct {
		uint8_t atr;
		uint8_t id;
		//unsigned char tam;
		uint32_t ant;
		uint32_t sig;
		uint32_t tareaoffini;
		/*
		uint8_t operator==(CapIdx &Idx){
			if(Idx.id==id && Idx.ant==ant && Idx.sig==sig)	return 1;
			else return 0;
		}
		*/
	}CapIdx;

	
	extern  CapFile Fi_ini,Fi_cur,Fi_fin;
	extern uint32_t toff;
	extern FIL hfile;
	
	extern CapIdx Idx_INI,Idx_FIN, Idx_CUR;
	extern FIL HIdx;
	extern TipoIdx TIdx;
	
	uint8_t Capsula_Igual(Capsula A,Capsula B);
	void LimpiarCapsula(void);
	
	void RampaBUS_Funcion(uint8_t fun);
	void Proceder_Funcion(void);
	
	
	
	extern uint8_t (*RBUS_Funcion[])(void);
	extern uint8_t INFUC;
	//----------------------------------microsd-----------------------
	uint8_t CargarArchivo(const char* path,FIL *fil);
	void AgregarTarea(void *tarea,uint16_t tam);
	//void EliminarTarea(void *tarea);
	//void ModificarTarea(Capsula in);
	uint8_t TNV_Sig(void);
	uint8_t TNV_Ant(void);
	void TNV_ObtenerTarea(void *tarea,CapFile *fi);
	void TNV_Cabecera_INI_FIN(uint8_t fin);
	void TNV_SeekOff(uint32_t off);
	void LeerCapFileTarea(CapFile *fi);
	//-----------------------------------IDX----------------------------
	void ConstruirBaseIdx(TipoIdx tidx);
	void CrearIdx(TipoIdx tidx);
	void CargarArchivoIdx(TipoIdx tidx);
	//------------------------------------funciones---------------------
	void PulgarRed(void);
	uint8_t RBUS_Vacio(void);
	uint8_t RBUS_ResPing(void);
	uint8_t RBUS_ObtenerDatos(void);
	uint8_t RBUS_Prueba(void);
	
		
#endif





